package
{
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	import org.osmf.net.dynamicstreaming.INetStreamMetrics;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/bg.png")] public static var BgImg:Class;
		[Embed(source = "data/titlebg.png")] public static var GameBg:Class;
		[Embed(source = "data/title.png")] public static var TitleImg:Class;
		[Embed(source = "data/numbers.png")] public static var ScoreImg:Class;
		//[Embed(source = "data/fish.png")] private var FishImg:Class;
		//[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		//[Embed(source = "data/fanfare.mp3")] public static var SndFanfare:Class;
		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/drop.mp3")] public static var SndDrop:Class;
		[Embed(source = "data/sfx.mp3")] public static var SndSfx:Class;
		//[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;
		
		private var _blur:Number;
		private var _helper:FlxSprite;
		private var _fg:FlxSprite;
		public var title:FlxSprite; 
		public var s1:FlxSprite;
		public var s2:FlxSprite;
		public var s3:FlxSprite;
		public var s4:FlxSprite;
		public var score:int;
		public var time:Number;
		
		public var c1x:int;
		public var c1y:int;
		public var c2x:int;
		public var c2y:int;
		
		public var grid:Vector.<Vector.<int> >;
		public var fillGrid:Vector.<Vector.<int> >;
		public var fillGrid2:Vector.<Vector.<int> >;
		
		public function clearFill():void
		{
			for (var i:int=0;i<fillGrid.length;i++)
			{
				for (var j:int=0;j<fillGrid[i].length;j++)
				{
					if (grid[i][j]==0)
						fillGrid[i][j]=1000;
					else
						fillGrid[i][j]=-1;
				}
			}
			fillGrid[c1x][c1y]=1000;
			fillGrid[c2x][c2y]=1000;
			fillcount=0;
		}
		
		public function deleteFill(n:int):void
		{
			var tempscore:int=0;
			
			for (var i:int=0;i<fillGrid.length;i++)
			{
				for (var j:int=0;j<fillGrid[i].length;j++)
				{
					if (fillGrid[i][j]==n)
					{
						grid[i][j]=0;
						tempscore++;
					}
				}
			}
			tempscore=Math.pow(tempscore,2);
			score+=tempscore;
			this.setScore();			
			FlxG.play(GameState.SndSfx);
		}
		
		public var doDropBlocks:Boolean;
		public function checkGrid():void
		{
			clearFill();
			var deleted:Boolean=false;
			for (var i:int=0;i<fillGrid.length;i++)
			{
				for (var j:int=0;j<fillGrid[i].length;j++)
				{
					if (fillGrid[i][j]==-1)
					{
						var count:int =floodFill(i,j,grid[i][j],fillcount);
						if (count>=4)
						{
							deleteFill(fillcount);
							deleted=true;
						}
						fillcount++;
					}
				}
			}
			if (deleted)
			{
				doDropBlocks=true;
			}
		}
		public var fillcount:int;
		
		public function floodFill(row:int, col:int,color:int,fillcolor:int):int 
		{		
			if (col < 0) return 0;
			if (row < 0) return 0;
			if (row >= 8) return 0;
			if (col >= 14) return 0;
			
			if (grid[row][col] != color)
				return 0;
			
			
			var count:int=0;
			if (fillGrid[row][col] == -1) {	
				fillGrid[row][col] = fillcolor;
				count++;
				count+=floodFill(row + 1, col,color,fillcolor);
				count+=floodFill(row - 1, col,color,fillcolor);
				count+=floodFill(row, col + 1,color,fillcolor);
				count+=floodFill(row, col - 1,color,fillcolor);
			}
			return count;
		}
		
		override public function create():void
		{
			leftheld=0;
			rightheld=0;
			FlxG.play(GameState.SndSfx);

			doDropBlocks=false;
			grid = new Vector.<Vector.<int> >;
			for (var i:int=0;i<8;i++)
			{
				var row:Vector.<int> = new Vector.<int>;
				for (var j:int=0;j<14;j++)
				{
					row.push(0);	
				}
				grid.push(row);
			}
			
			
			fillGrid = new Vector.<Vector.<int> >;
			for (i=0;i<8;i++)
			{
				row = new Vector.<int>;
				for (j=0;j<14;j++)
				{
					row.push(0);	
				}
				fillGrid.push(row);
			}					
			
			time=0;
			score=0;
			_blur=0.9;
			_helper = new FlxSprite();
			_helper.loadGraphic(GameState.BgImg,true,false,576,384);
			_helper.addAnimation("play",[0,1],1,true);
			_helper.play("play",true);
			_helper.alpha = _blur;	
			
			_fg = new FlxSprite(0,0);
			_fg.createGraphic(48,32,0x01000000,true);			
			_fg.scale.x=12;
			_fg.scale.y=12;
			_fg.x=576/2-48/2;
			_fg.y=384/2-32/2;
			this.add(_fg);
			
			
			title = new FlxSprite(0,0);
			title.loadGraphic(GameState.GameBg);
			title.scale.x=12;
			title.scale.y=12;
			title.x=576/2-48/2;
			title.y=384/2-32/2;
			this.add(title);
			
			s1 = new FlxSprite(0,0);
			s1.loadGraphic(ScoreImg,true,false,4,6);
			s1.addAnimation("0",[0]);
			s1.addAnimation("1",[1]);
			s1.addAnimation("2",[2]);
			s1.addAnimation("3",[3]);
			s1.addAnimation("4",[4]);
			s1.addAnimation("5",[5]);
			s1.addAnimation("6",[6]);
			s1.addAnimation("7",[7]);
			s1.addAnimation("8",[8]);
			s1.addAnimation("9",[9]);
			s1.scale.x=12;
			s1.scale.y=12;
			s1.x=33*12 + 12*4/2 -4/2;
			s1.y=12 + 12*6/2 - 6/2;
			this.add(s1);
			
			s2 = new FlxSprite(0,0);
			s2.loadGraphic(ScoreImg,true,false,4,6);
			s2.addAnimation("0",[0]);
			s2.addAnimation("1",[1]);
			s2.addAnimation("2",[2]);
			s2.addAnimation("3",[3]);
			s2.addAnimation("4",[4]);
			s2.addAnimation("5",[5]);
			s2.addAnimation("6",[6]);
			s2.addAnimation("7",[7]);
			s2.addAnimation("8",[8]);
			s2.addAnimation("9",[9]);
			s2.scale.x=12;
			s2.scale.y=12;
			s2.x=33*12 + 12*4/2 -4/2;
			s2.y=12 + 12*6/2 - 6/2+7*12;
			this.add(s2);
			
			s3 = new FlxSprite(0,0);
			s3.loadGraphic(ScoreImg,true,false,4,6);
			s3.addAnimation("0",[0]);
			s3.addAnimation("1",[1]);
			s3.addAnimation("2",[2]);
			s3.addAnimation("3",[3]);
			s3.addAnimation("4",[4]);
			s3.addAnimation("5",[5]);
			s3.addAnimation("6",[6]);
			s3.addAnimation("7",[7]);
			s3.addAnimation("8",[8]);
			s3.addAnimation("9",[9]);
			s3.scale.x=12;
			s3.scale.y=12;
			s3.x=33*12 + 12*4/2 -4/2;
			s3.y=12 + 12*6/2 - 6/2+2*7*12;
			this.add(s3);
			
			s4 = new FlxSprite(0,0);
			s4.loadGraphic(ScoreImg,true,false,4,6);
			s4.addAnimation("0",[0]);
			s4.addAnimation("1",[1]);
			s4.addAnimation("2",[2]);
			s4.addAnimation("3",[3]);
			s4.addAnimation("4",[4]);
			s4.addAnimation("5",[5]);
			s4.addAnimation("6",[6]);
			s4.addAnimation("7",[7]);
			s4.addAnimation("8",[8]);
			s4.addAnimation("9",[9]);
			s4.scale.x=12;
			s4.scale.y=12;
			s4.x=33*12 + 12*4/2 -4/2;
			s4.y=12 + 12*6/2 - 6/2+3*7*12;
			this.add(s4);
			
			setScore();
			newPiece();
		}
		
		public function setScore():void
		{
			var d1:int=score%10;
			var d2:int=(score/10)%10;
			var d3:int=(score/100)%10;
			var d4:int=(score/1000)%10;
			s1.play(d1.toString(),true);
			s2.play(d2.toString(),true);
			s3.play(d3.toString(),true);
			s4.play(d4.toString(),true);
		}
		
		public const tick:Number=0.4;
		
		public function newPiece():void
		{
			FlxG.play(GameState.SndDrop);

			if (grid[int(8/2)][0]!=0 || grid[int(8/2)][1]!=0)
			{
				FlxG.state=new TitleState();
			}
			
			c1x=8/2;
			c1y=0;
			c2x=c1x;
			c2y=1;
			grid[c1x][c1y]=1+int(Math.random()*4);
			grid[c2x][c2y]=1+int(Math.random()*4);
			trace(grid[c1x][c1y].toString() + "," + grid[c2x][c2y].toString());
		}
		
		public function dropDown():void
		{
			if (c2y==13 || grid[c2x][c2y+1]!=0)
			{
				newPiece();
				checkGrid();
				return;
			}
			
			grid[c2x][c2y+1]=grid[c2x][c2y];
			grid[c1x][c1y+1]=grid[c1x][c1y];
			grid[c1x][c1y]=0;
			c1y++;
			c2y++;		
		}
		
		public var leftheld:Number;
		public var rightheld:Number;
		
		override public function update():void
		{
			if (doDropBlocks)
			{
				doDropBlocks=false;
				
				var movedsomething:Boolean=false;
				for (i=0;i<grid.length;i++)
				{
					var moved:Boolean=true;
					while(moved)
					{
						moved=false;
						for (var j:int=grid[i].length-1;j>0;j--)
						{
							if (i==c2x && j-1==c2y)
							{
								break;
							}
							
							if (i==c1x && j-1==c1y)
							{
								break;
							}
							
							if (grid[i][j]==0 && grid[i][j-1]!=0)
							{
								grid[i][j]=grid[i][j-1];
								grid[i][j-1]=0;
								moved=true;
							}
						}		
						if (moved)
							movedsomething=true;
					}					
				}
				
				if (movedsomething)
				{
					checkGrid();	
				}
			}
			if (FlxG.keys.justPressed("UP"))
			{
				var tempn:int=grid[c1x][c1y];
				grid[c1x][c1y]=grid[c2x][c2y];
				grid[c2x][c2y]=tempn;
			}
			if (FlxG.keys.justPressed("LEFT") || (FlxG.keys.LEFT && leftheld>0.2) )
			{
				if (c1x==0 || c1y==0)
				{
					
				}
				else if (grid[c1x-1][c1y]==0&& grid[c2x-1][c2y]==0)
				{
					grid[c1x-1][c1y]=grid[c1x][c1y];
					grid[c1x][c1y]=0;
					grid[c2x-1][c2y]=grid[c2x][c2y];
					grid[c2x][c2y]=0;
					c1x--;
					c2x--;
				}
				else
				{
					
				}
			}
			else
			{
			  if (!FlxG.keys.LEFT)
			  {
				leftheld=0;
			  }
			  else
			  {
				  leftheld+=FlxG.elapsed;
			  }
			}
			
			
			if (FlxG.keys.justPressed("RIGHT")|| (FlxG.keys.RIGHT && rightheld>0.2) )
			{
				if (c1x==7 || c1y==7)
				{
					
				}
				else if (grid[c1x+1][c1y]==0 && grid[c2x+1][c2y]==0)
				{
					grid[c1x+1][c1y]=grid[c1x][c1y];
					grid[c1x][c1y]=0;
					grid[c2x+1][c2y]=grid[c2x][c2y];
					grid[c2x][c2y]=0;
					c1x++;
					c2x++;
				}
				else
				{
					
				}
			}
			else
			{
				if (!FlxG.keys.RIGHT)
				{
					rightheld=0;
				}
				else
				{
					rightheld+=FlxG.elapsed;
				}
			}
			
			_fg._pixels.fillRect(_fg._pixels.rect,0);
			
			time+=FlxG.elapsed;
			
			if (time>=tick)
			{
				time=0;
				dropDown();
			}
			else if (FlxG.keys.DOWN)
			{
				dropDown();
			}
			
			for (var i:int=0;i<grid.length;i++)
			{
				for (j=0;j<grid[i].length;j++)
				{
					switch (grid[i][j])
					{
						case 1:
							if (time<0.25*tick)
							{
								_fg._pixels.setPixel32(10+2*i,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i,	2+2*j+1,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j+1,0xff000000);
							}
							break;						
						case 2:
							if (time<0.5*tick)
							{
								_fg._pixels.setPixel32(10+2*i,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i,	2+2*j+1,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j+1,0xff000000);
							}
							break;
						case 3:
							if (time<0.75*tick)
							{
								_fg._pixels.setPixel32(10+2*i,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i,	2+2*j+1,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j+1,0xff000000);
							}
							break;					
						case 4:
							{
								_fg._pixels.setPixel32(10+2*i,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j,0xff000000);
								_fg._pixels.setPixel32(10+2*i,	2+2*j+1,0xff000000);
								_fg._pixels.setPixel32(10+2*i+1,	2+2*j+1,0xff000000);
							}
							break;
					}
				}
			}
			
			_fg.resetHelpers();
			
			super.update();
		}
		override public function preProcess():void
		{
			screen.draw(_helper);
		}
	}
}